Integer Break: Unraveling Dynamic Programming

Here is the problem, by Leetcode. First try to think of the brute-force approach. https://leetcode.com/problems/integer-break/description/

Given a positive integer n, break it into the sum of at least two positive integers and maximize the product of those integers. Return the maximum product you can get.
Example 1:
Input: 2
Output: 1
Explanation: 2 = 1 + 1, 1 × 1 = 1.
Example 2:
Input: 10
Output: 36
Explanation: 10 = 3 + 3 + 4, 3 × 3 × 4 = 36.
Note: You may assume that n is not less than 2 and not larger than 58.
The brute-force will certainly be exponential. This problem is screaming for a DP solution, but coming up with exactly the "formula" for it is the challenge.
Here is the way that I thought about the problem: as always, DP will be a construction approach, hence we'll build the solution for 1, 2, 3, ...., all the way to N, in our case N <= 58. Let's focus on a certain number N.
One possibility is clear: the solution for N might just be the best with 2 numbers only: (N-1)*1, or (N-2)*2, .... In general, (N-i)*i, for all i from 1 to N-1. But this only gives us the solution with 2 numbers in the addition. There might be many more numbers.
OK, in this case then, the other option is to assume that the solution for N-i has already been found with as many numbers as it gets, we just don't care, we simply assume that it exists. Let's assume that the solution has been stored in an array and we'll call that solution DP[N-i]. Well, in this case another possible alternative is DP[N-i] * i, right? Since we still need to add i to N-i to get to N.
In essence, the solution for DP[N] then becomes:

DP[N] = Max( (N-i) * i, DP[N-i] * i)

The picture below exemplifies this process:


With that in hands, all gosh, the code becomes a ridiculous (N^2)-time, N-space, 5-liners. Code is below, thanks, A.C.C.


public class Solution
{
 public int IntegerBreak(int n)
 {
  int[] dp = new int[n + 1];
  for (int i = 2; i <= n; i++)
   for (int j = 1; j < i; j++)
    dp[i] = Math.Max((i - j) * j, Math.Max(dp[i - j] * j, dp[i]));
  return dp[n];
 }
}

Comments

  1. That's a great general approach for solving this problem, but it can also be solved in a much more simple way by noting that in order to maximize the product of values that are greater than 4 it's always beneficial to chip off as many 3s as possible instead of using larger values. The proof of this fact is left as an exercise, but the solution is below:

    impl Solution {
    pub fn integer_break(n: i32) -> i32 {
    if n == 2 {
    return 1; // 1 * 1
    }
    if n == 3 {
    return 2; // 1 * 2
    }
    let mut product = 1;
    let mut tmp = n;
    while tmp > 4 {
    product *= 3;
    tmp -= 3;
    }
    return product * tmp;
    }
    }

    https://gist.github.com/ttsugriy/51d0b17a315ce14918df81c102ada808

    ReplyDelete

Post a Comment

Popular posts from this blog

Count Binary Substrings

Count Vowels Permutation: Standard DP

Maximum Number of Balloons